/*
 *  com/mmbreakfast/unlod/app/PreferencesDialog.java
 *
 *  Copyright (C) 2000 Sil Veritas (sil_the_follower_of_dark@hotmail.com)
 */

/*  This file is part of Unlod.
 *
 *  Unlod is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Unlod is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Unlod; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*  Unlod
 *
 *  Copyright (C) 2000 Sil Veritas. All Rights Reserved. This work is
 *  distributed under the W3C(R) Software License [1] in the hope that it
 *  will be useful, but WITHOUT ANY WARRANTY; without even the implied
 *  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  [1] http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
 */

package com.mmbreakfast.unlod.app;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.mmbreakfast.util.*;


public class PreferencesDialog extends JDialog {
   protected static final String TITLE = "Preferences";
   private JButton okButton            = new JButton("OK");
   private JButton cancelButton        = new JButton("Cancel");
   private JPanel buttonPanel          = new JPanel(new GridLayout(1, 2, 4, 4));
   protected Frame parent;
   protected Preferences preferences;

   public PreferencesDialog(Frame parent, Preferences preferences) {
   	super(parent, TITLE, true);
      this.parent = parent;
      this.preferences = preferences;

      this.setResizable(false);

   	JPanel cp = (JPanel) this.getContentPane();
   	cp.setLayout(new GridBagLayout());

   	buttonPanel.add(okButton);
   	buttonPanel.add(cancelButton);

   	ComponentDeployer.deploy(cp, buttonPanel,  GridBagConstraints.SOUTH,     GridBagConstraints.REMAINDER, 1, GridBagConstraints.NONE, 0.0, 0.0, new Insets(15, 15, 15, 15));
   	this.pack();
      WindowUtilities.centerOnScreen(this);

   	this.addWindowListener(new WindowAdapter() {
   	   public void windowClosing(WindowEvent e) {
   	      PreferencesDialog.this.dispose();
   	   }
   	});

   	cancelButton.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
   	      PreferencesDialog.this.dispose();
   	   }
   	});

   	okButton.addActionListener(new ActionListener() {
   	   public void actionPerformed(ActionEvent e) {
   	   }
   	});

   	this.getRootPane().setDefaultButton(okButton);
   }
}